

; ==============================================
;
;    Creates a toolbar using CreateWindowEx by specifying the TOOLBARCLASSNAME window class
;    The created toolbar initially contains no buttons  
; ==============================================


    .586                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\macros\macros.asm
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\msvcrt.lib

    ; ======= Prototypes =======

    WinMain    PROTO :DWORD, :DWORD, :DWORD, :DWORD
    WindowProc PROTO :DWORD, :DWORD, :DWORD, :DWORD

    .const
      ID_TOOLBAR  equ    100

      ID_BUTTON    equ    120
      ID_BUTTON1   equ    121
      ID_BUTTON2   equ    122
      ID_BUTTON3   equ    123
      ID_BUTTON4   equ    124        

      NUM_BUTTONS  equ     5    

   .data?

    .data

      hinstance     dd        0
      hwnd          dd        0
      htoolbar      dd        0

      windowname    db   "WindowForge",0
      wclassname    db   "classforge",0
      menuname      db   "Filemenu",0
      pcommandline  dd        0

      TOOLBARCLASSNAME  db    "ToolbarWindow32", 0              ; system class


      icc           INITCOMMONCONTROLSEX            { }
      tb_btn        TBBUTTON   NUM_BUTTONS dup    ({}) 
      
      str_msg  db "btn txt", 0,0


; =============================================================================================


    .code

start:


    invoke GetModuleHandle, NULL
    mov hinstance, eax                  ; instance handle of this application.

    invoke GetCommandLine
    mov pcommandline, eax               ; fetch the command line address


    mov icc.dwSize, sizeof INITCOMMONCONTROLSEX
    mov icc.dwICC, ICC_BAR_CLASSES

 ;  load the common control dynamic-link library & register the class

    invoke InitCommonControlsEx, addr icc
    cmp eax, 0
    jne @F
    fn MessageBox,0,"Common Controls Loading Failed","Title",MB_OK

  @@:
    invoke WinMain, hinstance, NULL, NULL, SW_SHOWDEFAULT
    invoke ExitProcess, eax             ; close this application after the win is destroyed

  
WinMain proc hInstance:DWORD, hPrevInstance:DWORD, lpCmdLine:DWORD, nCmdShow:DWORD

      LOCAL wcl   :WNDCLASSEX
      LOCAL msg   :MSG


    mov ecx, hInstance             ; handle to the current instance of the application

    

; -----------------------------------------------------------------------------------
;      fill up the  WNDCLASSEX  structure 
; -----------------------------------------------------------------------------------

      mov wcl.cbSize,           sizeof WNDCLASSEX
      mov wcl.style,            CS_HREDRAW or CS_VREDRAW \
                        or      CS_BYTEALIGNWINDOW
      mov wcl.lpfnWndProc,      offset WindowProc
      mov wcl.cbClsExtra,       0                   ; 0 = extra memory not used, 40bytes max
      mov wcl.cbWndExtra,       0
      mov wcl.hInstance,        ecx 
      invoke LoadIcon,NULL, IDI_ASTERISK
      mov wcl.hIcon,            eax                 ; ALT+TAB icon etc
      invoke LoadCursor, NULL, IDC_ARROW            ; predefined cursor (could use LoadImage)
      mov wcl.hCursor,          eax
      mov wcl.hbrBackground,    COLOR_BTNFACE+1
      mov wcl.lpszMenuName,     0
      mov wcl.lpszClassName,    offset wclassname
      mov wcl.hIconSm,          NULL                ; window's title bar icon etc

  
    invoke RegisterClassEx, addr wcl                ; Register the Class

; Create the Main Wundow

    invoke CreateWindowEx,
           WS_EX_OVERLAPPEDWINDOW,
           addr wclassname, 
           addr windowname,        
           WS_OVERLAPPEDWINDOW\
                 or WS_HSCROLL\   
                 or WS_VSCROLL,
           CW_USEDEFAULT, 
           CW_USEDEFAULT,
           CW_USEDEFAULT,
           CW_USEDEFAULT, 
           NULL,
           NULL,
           hInstance,                      
           NULL                             

    mov hwnd, eax                           ; returns the handle to the new window created.

    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd               ; Updates the client area by sending a WM_PAINT
                                            ; msg if the window's update region is not empty.


    MessageLoop:                              ; checks return values from the GetMessage Function
      invoke GetMessage, addr msg, NULL, 0, 0 ; retrieves a msg & removes it from the que
                                          
      .if eax == SDWORD ptr -1                ; === check for an error ===
        push eax
        fn MessageBox, 0, "GetMessage Error", "Error", MB_OK
        pop eax
        invoke DestroyWindow, hwnd
      .endif                              
                                          
      cmp eax, 0                          ; check if 0 (WM_QUIT message retrieved by GetMessage)
        jz ExitMsgLoop                    ; if 0 , then exit the Loop.
        invoke TranslateMessage, addr msg 
        invoke DispatchMessage,  addr msg ; else Dispatch the Message to the WndProc for the window
        jmp MessageLoop
    ExitMsgLoop:
      mov eax, msg.wParam                 ; return the value passed in the WM_QUIT message's
      ret                                 ; wParam parameter.

  WinMain endp

; ----------------------------------------------------------------------------------------------------------------------------------------------------

    WindowProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD


      .if uMsg == WM_CREATE

          mov eax, hWnd
          mov hwnd, eax
          call create_toolbar
          return 0

      .elseif uMsg == WM_PARENTNOTIFY

      .elseif uMsg == WM_PAINT

      .elseif uMsg == WM_ERASEBKGND

      .elseif uMsg == WM_SIZE

      .elseif uMsg == WM_DESTROY
         
          invoke PostQuitMessage, NULL                ; if the main window is being destroyed
          return 0                                    ; 0 = proc processed the msg

      .elseif uMsg == WM_CLOSE
          invoke DestroyWindow, hWnd                  ; sends a WM_DESTROY Message 
          return 0

      .endif
    
      default_processing:
      invoke DefWindowProc, hWnd, uMsg, wParam, lParam   ; default processing
        
      ret

    WindowProc endp

; ---------------------------------------------------------
;     Create  the Toolbar & Buttons
; -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  

create_toolbar:

    push esi
    push ebx

; fn MessageBox,0,str$(hwnd),"hwnd",MB_OK

      invoke CreateWindowEx, 0, addr TOOLBARCLASSNAME, 0, WS_CHILD or CCS_ADJUSTABLE, 0, 0, 0, 0,
      hwnd, ID_TOOLBAR, hinstance, 0
      mov htoolbar, eax
      cmp eax, 0
      jne @F
      invoke GetLastError
      fn MessageBox,0,str$(eax),"Title",MB_OK

@@:

   ; mov [esi].TBBUTTON.fsStyle, BTNS_BUTTON or TBSTYLE_ALTDRAG
   ; mov ((type TBBUTTON) ptr [esi]).fsStyle, BTNS_BUTTON or TBSTYLE_ALTDRAG


  ; - - - Initialize the TBUTTON Structures - - - 

      mov esi, offset tb_btn

      mov [esi.TBBUTTON.iBitmap], I_IMAGENONE
      mov [esi.TBBUTTON.idCommand], ID_BUTTON
      mov [esi].TBBUTTON.fsState, TBSTATE_ENABLED or TBSTATE_PRESSED
      mov [esi].TBBUTTON.fsStyle, BTNS_BUTTON
      mov [esi.TBBUTTON.dwData], 0
      mov [esi.TBBUTTON.iString], 0

      add esi, SIZEOF TBBUTTON

      mov [esi.TBBUTTON.iBitmap], I_IMAGENONE
      mov [esi.TBBUTTON.idCommand], ID_BUTTON1
      mov [esi].TBBUTTON.fsState, TBSTATE_ENABLED or TBSTATE_PRESSED
      mov [esi].TBBUTTON.fsStyle, BTNS_BUTTON
      mov [esi.TBBUTTON.dwData], 0
      mov [esi.TBBUTTON.iString], 0

      add esi, SIZEOF TBBUTTON

      mov [esi.TBBUTTON.iBitmap], I_IMAGENONE
      mov [esi.TBBUTTON.idCommand], ID_BUTTON2
      mov [esi].TBBUTTON.fsState, TBSTATE_ENABLED
      mov [esi].TBBUTTON.fsStyle, BTNS_SEP
      mov [esi.TBBUTTON.dwData], 0
      mov [esi.TBBUTTON.iString], 0

      add esi, SIZEOF TBBUTTON
      
      mov [esi.TBBUTTON.iBitmap], I_IMAGENONE
      mov [esi.TBBUTTON.idCommand], ID_BUTTON3
      mov [esi].TBBUTTON.fsState, TBSTATE_ENABLED or TBSTATE_PRESSED
      mov [esi].TBBUTTON.fsStyle, BTNS_BUTTON
      mov [esi.TBBUTTON.dwData], 0
      mov [esi.TBBUTTON.iString], 0

      add esi, SIZEOF TBBUTTON

      mov [esi.TBBUTTON.iBitmap], I_IMAGENONE
      mov [esi.TBBUTTON.idCommand], ID_BUTTON4
      mov [esi].TBBUTTON.fsState, TBSTATE_ENABLED or TBSTATE_PRESSED
      mov [esi].TBBUTTON.fsStyle, BTNS_BUTTON
      mov [esi.TBBUTTON.dwData], 0
      mov [esi.TBBUTTON.iString],offset str_msg

comment 
      mov esi, offset tb_btn
      add esi, SIZEOF TBBUTTON*4
      xor ebx, ebx
      mov ebx, [esi].TBBUTTON.idCommand
      cmp ebx, ID_BUTTON4
      jne @F
      
      fn MessageBox,0,str$(ebx),"Button-4 ID",MB_OK


   @@:
    
      invoke SendMessage, htoolbar, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
      invoke SendMessage, htoolbar, TB_ADDBUTTONS, NUM_BUTTONS, addr tb_btn
      mov ebx, 2
      cmp eax, 0
      je error_
      invoke SendMessage, htoolbar, TB_AUTOSIZE, 0, 0
      invoke ShowWindow , htoolbar, SW_SHOW

   error_:
        fn MessageBox,0,"error","Title",MB_OK
        fn MessageBox,0,str$(ebx),"error index",MB_OK

   @@: 
      mov eax, htoolbar

      pop ebx
      pop esi

ret

end start






